﻿using System;
using System.Collections.ObjectModel;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;

namespace WpfApp1
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var source = new ObservableCollection<RowInfo>();
            for (int i = 0; i < 10; i++)
            {
                source.Add(new RowInfo() { IsChecked = i % 2 == 0 });
            }
            DataContext = source;
        }
    }

    public class RowInfo
    {
        public bool IsChecked { get; set; }
    }

    public class CustomGridViewCheckBoxColumn : GridViewCheckBoxColumn
    {
        public Style CellContentStyle
        {
            get { return (Style)GetValue(CellContentStyleProperty); }
            set { SetValue(CellContentStyleProperty, value); }
        }

        public static readonly DependencyProperty CellContentStyleProperty =
            DependencyProperty.Register("CellContentStyle", typeof(Style), typeof(CustomGridViewCheckBoxColumn), new PropertyMetadata(null, OnCellContentStyleChanged));

        private static void OnCellContentStyleChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            var column = (GridViewCheckBoxColumn)d;
            column.DataControl.Rebind();
        }

        public override FrameworkElement CreateCellElement(GridViewCell cell, object dataItem)
        {
            var element = (GridViewCheckBox)base.CreateCellElement(cell, dataItem);
            element.Style = this.CellContentStyle;
            return element;
        }
    }
}
